#pragma once
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>
#include <cstdlib>
#include <gsl/gsl_spline.h>

#include "math/matrix.hh"
#include "commons.hh"

using namespace std;



namespace HELL {

  class xTableU {
  protected:
    double *xx;
    int Np1, Np2;
    double x_min, x_mid, x_max;
    double interpolate(double x);
    //
    int Nxi;
    double *xi_, **xdU, *xdUqg;
    gsl_spline *dUspline;
    //gsl_interp_accel *acc;
    //void Init();
  public:
    xTableU(string filename);
    ~xTableU() { delete[] xx; delete[] xi_; for(int i=0; i<Nxi; i++) {delete[] xdU[i];} delete[] xdU; delete dUspline; };
    double evalU  (double x, double xi, double &deriv);
    double evalUqg(double x);
  };



  extern void SetRCmodeCFnew(unsigned int mode=0);  // mode=0 uses gammadot, mode=1 uses as*beta0

  extern double DeltaUqgRes(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaKhgRes(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaCLRes (double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaC2Res (double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLRes(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2Res(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLResAxial(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2ResAxial(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLResCC(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2ResCC(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC3ResCC(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaHggAuxRes(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaCDYRes(double x, double as, double nf, xTableU *tU, double muFrat, void *pars=NULL);


};

